apeman-demo-api
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]
[![JS Standard][bd_standard_shield_url]][bd_standard_url]

[bd_repo_url]: https://github.com/apeman-api-labo/apeman-demo-api
[bd_travis_url]: http://travis-ci.org/apeman-api-labo/apeman-demo-api
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-api-labo/apeman-demo-api.svg?style=flat
[bd_travis_com_url]: http://travis-ci.com/apeman-api-labo/apeman-demo-api
[bd_travis_com_shield_url]: https://api.travis-ci.com/apeman-api-labo/apeman-demo-api.svg?token=
[bd_license_url]: https://github.com/apeman-api-labo/apeman-demo-api/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-api-labo/apeman-demo-api
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-api-labo/apeman-demo-api.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-api-labo/apeman-demo-api.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-api-labo/apeman-demo-api
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-api-labo/apeman-demo-api.svg
[bd_npm_url]: http://www.npmjs.org/package/apeman-demo-api
[bd_npm_shield_url]: http://img.shields.io/npm/v/apeman-demo-api.svg?style=flat
[bd_standard_url]: http://standardjs.com/
[bd_standard_shield_url]: https://img.shields.io/badge/code%20style-standard-brightgreen.svg

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

Demo of api projects

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>



<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/guides/01.Installation.md.hbs" Start -->

<a name="section-doc-guides-01-installation-md"></a>

Installation
-----

```bash
$ npm install apeman-demo-api --save
```


<!-- Section from "doc/guides/01.Installation.md.hbs" End -->

<!-- Section from "doc/guides/02.Usage.md.hbs" Start -->

<a name="section-doc-guides-02-usage-md"></a>

Usage
---------

Define a module in Apemanfile and run the server.

```javascript
/** Example of Apemanfile.js */

'use strict'

const co = require('co')

let { NODE_ENV } = process.env

module.exports = {
  $cwd: __dirname,
  $pkg: { /* ... */ },
  $proto: [ /* ... */ ],
  $api: {
    // Define APIs
    'module01': require('apeman-demo-api')({
      logging: NODE_ENV === 'development'
    })
  }
}

```

Then, call the module from client script

```javascript
#!/usr/bin/env node

/**
 * Example client
 */
'use strict'

const co = require('co')
const apemanApiClient = require('apeman-api-client')

co(function * () {
  // Setup an client
  let api = yield apemanApiClient('/api')

  // Connect to a module
  let module01 = yield api.connect('module01')
  let pong = yield module01.ping()
  /* ... */
})


```


<!-- Section from "doc/guides/02.Usage.md.hbs" End -->

<!-- Section from "doc/guides/03.Methods.md.hbs" Start -->

<a name="section-doc-guides-03-methods-md"></a>

Methods
---------

The following methods are provided by the API.

+ [.ping(pong)](#method-ping)

<a name="method-ping"></a>
### .ping(pong)

Test the reachability of the api.

| Param | Type | Description |
| ----- | ---- | ----------- |
| pong  | <code>string</code> | Pong message to return |



<!-- Section from "doc/guides/03.Methods.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-api-labo/apeman-demo-api/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman][apeman_url]

[apeman_url]: https://github.com/apeman-labo/apeman

<!-- Links End -->
